%define name FJSVdr-util-RHEL7
%define version 1.8.0
%define release 1

%define dp_home_dir    /opt/FJSVdr-util
%define dp_etc_dir     /opt/FJSVdr-util/etc
%define dp_lib_dir     /opt/FJSVdr-util/lib
%define dp_libexec_dir /opt/FJSVdr-util/libexec
%define dp_core_dir    /opt/FJSVdr-util/libexec/dp-core
%define dp_sbin_dir    /opt/FJSVdr-util/sbin
%define dp_tools_dir   /opt/FJSVdr-util/tools
%define dp_log_dir     /opt/FJSVdr-util/var/log
%define dp_com_dir     /opt/FJSVdr-util/user_command
%define python_lib     /usr/lib/python2.7/site-packages
%define udev_rule_dir  /etc/udev/rules.d
%define systemd_dir    /usr/lib/systemd/system
%define default_grub	/etc/default/grub
%define grub_cfg	/boot/efi/EFI/redhat/grub.cfg
%define dp_boot_opt	"pci=hpiosize=0 pci=hpmemsize=8m pciehp.pciehp_force=1 notsc mem=0x40000000000"

Name:        %{name}
Version:     %{version}
Release:     %{release}
Summary:     Dynamic Reconfiguration utility for PRIMEQUEST 2000 series and PRIMEQUEST 3000 series.

Group:       System Environment/Base
License:     GPLv2
Vendor:      FUJITSU LIMITED
Packager:    FUJITSU LIMITED
URL:         http://www.fujitsu.com/
Source0:     %{name}-%{version}.tar.bz2
Source1:     10-FJSVdr-util-kdump-restart
Source2:     90-FJSVdr-util-detect-passthrough-dev
Source3:     89-FJSVdr-util-irqbalance-restart
Source4:     88-FJSVdr-util-detect-enabled-ksm-service
Source5:     87-FJSVdr-util-libvirtd-restart
BuildRoot:   %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
BuildArch:   noarch
Obsoletes:   FJSVdr-util-RHEL6
Requires:    python >= 2.7
Requires:    grubby
Requires:    ipmitool
Requires:    kexec-tools
Requires:    OpenIPMI
Requires:    bc

%description
Provides a set of Dynamic Reconfiguration command user interface
and related service scripts. And also provides some Dynamic
Reconfiguration collaborate scripts.

%prep
%setup -q
#%patch1 -p1

%build

%install
rm -rf $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT%{dp_etc_dir}
mkdir -p $RPM_BUILD_ROOT%{dp_lib_dir}
mkdir -p $RPM_BUILD_ROOT%{dp_libexec_dir}
mkdir -p $RPM_BUILD_ROOT%{dp_core_dir}
mkdir -p $RPM_BUILD_ROOT%{dp_sbin_dir}
mkdir -p $RPM_BUILD_ROOT%{dp_tools_dir}
mkdir -p $RPM_BUILD_ROOT%{dp_log_dir}
mkdir -p $RPM_BUILD_ROOT%{dp_com_dir}
mkdir -p $RPM_BUILD_ROOT%{_sysconfdir}/logrotate.d
mkdir -p $RPM_BUILD_ROOT%{systemd_dir}

# etc
install -m 0644 -o root -g root \
	etc/dr_report.conf $RPM_BUILD_ROOT%{dp_etc_dir}
# lib
install -m 0644 -o root -g root \
	lib/dp.py $RPM_BUILD_ROOT%{dp_lib_dir}
install -m 0644 -o root -g root \
	lib/ipmi.py $RPM_BUILD_ROOT%{dp_lib_dir}
install -m 0644 -o root -g root \
	lib/dp_compat.py $RPM_BUILD_ROOT%{dp_lib_dir}
install -m 0644 -o root -g root \
	lib/notify.py $RPM_BUILD_ROOT%{dp_lib_dir}
# libexec
install -m 0755 -o root -g root \
	libexec/udev_dp_bridge.py $RPM_BUILD_ROOT%{dp_libexec_dir}
install -m 0755 -o root -g root \
	libexec/dp_send_ready.py $RPM_BUILD_ROOT%{dp_libexec_dir}
install -m 0755 -o root -g root \
	libexec/dp_send_not_ready.py $RPM_BUILD_ROOT%{dp_libexec_dir}
install -m 0755 -o root -g root \
	libexec/dp_event_daemon.py $RPM_BUILD_ROOT%{dp_libexec_dir}
install -m 0755 -o root -g root \
	libexec/dp_event_notifier.py $RPM_BUILD_ROOT%{dp_libexec_dir}
install -m 0755 -o root -g root \
	libexec/dp_enable_removable_sb.py $RPM_BUILD_ROOT%{dp_libexec_dir}
# dp-core
install -m 0755 -o root -g root \
	libexec/dp-core/dp_add.py $RPM_BUILD_ROOT%{dp_core_dir}
install -m 0755 -o root -g root \
	libexec/dp-core/dp_rm.py $RPM_BUILD_ROOT%{dp_core_dir}
install -m 0755 -o root -g root \
	libexec/dp-core/dp_show.py $RPM_BUILD_ROOT%{dp_core_dir}
install -m 0755 -o root -g root \
	libexec/dp-core/dp_stat.py $RPM_BUILD_ROOT%{dp_core_dir}
install -m 0755 -o root -g root \
	libexec/dp-core/dp_report.py $RPM_BUILD_ROOT%{dp_core_dir}
# sbin
install -m 0755 -o root -g root \
	sbin/dp $RPM_BUILD_ROOT%{dp_sbin_dir}/dr
# tools
install -m 0644 -o root -g root \
	tools/RHEL7/FJSVdr-util.rules $RPM_BUILD_ROOT%{dp_tools_dir}
install -m 0755 -o root -g root \
	tools/udev_dp_bridge.sh $RPM_BUILD_ROOT%{dp_tools_dir}
# systemd service
install -m 0644 -o root -g root \
	tools/RHEL7/FJSVdr-util-enable.service $RPM_BUILD_ROOT%{systemd_dir}
install -m 0644 -o root -g root \
	tools/RHEL7/FJSVdr-util-event-daemon.service $RPM_BUILD_ROOT%{systemd_dir}
install -m 0644 -o root -g root \
	tools/RHEL7/FJSVdr-util-enable-removable-sb.service $RPM_BUILD_ROOT%{systemd_dir}
# logrotate file
install -m 0644 -o root -g root tools/common/FJSVdr-util.logrotate \
	$RPM_BUILD_ROOT%{_sysconfdir}/logrotate.d/FJSVdr-util
# user_command
install -m 0755 -o root -g root %{SOURCE1} $RPM_BUILD_ROOT%{dp_com_dir}
install -m 0755 -o root -g root %{SOURCE2} $RPM_BUILD_ROOT%{dp_com_dir}
install -m 0755 -o root -g root %{SOURCE3} $RPM_BUILD_ROOT%{dp_com_dir}
install -m 0755 -o root -g root %{SOURCE4} $RPM_BUILD_ROOT%{dp_com_dir}
install -m 0755 -o root -g root %{SOURCE5} $RPM_BUILD_ROOT%{dp_com_dir}

%post
if [ "$1" = 1 ]; then  # when rpm -i
	## install service
	/usr/bin/systemctl enable FJSVdr-util-enable.service >/dev/null 2>&1
	/usr/bin/systemctl enable FJSVdr-util-event-daemon.service >/dev/null 2>&1
	/usr/bin/systemctl enable FJSVdr-util-enable-removable-sb.service >/dev/null 2>&1
	
	## for kdump
	if [ -f /etc/udev/rules.d/98-kexec.rules ]; then
		/bin/sed -i -e "s/^/#/g" /etc/udev/rules.d/98-kexec.rules
	fi
fi
## overwrite 98-kexec.rules and 40-redhat-rules
## for kdump on RHEL7.1 or later
if [ -f /usr/lib/udev/rules.d/98-kexec.rules ]; then
	/bin/cp -f /usr/lib/udev/rules.d/98-kexec.rules /etc/udev/rules.d/
	/bin/sed -i -e "s/^/#/g" /etc/udev/rules.d/98-kexec.rules
fi

## for CPU online/offline on RHEL7.1 or later
if [ -f /usr/lib/udev/rules.d/40-redhat.rules ]; then
	/bin/echo -e '# there was edited by dr-util\nSUBSYSTEM=="memory", GOTO="dr_end"\nSUBSYSTEM=="cpu", GOTO="dr_end"' > /etc/udev/rules.d/40-redhat.rules
	/bin/cat /usr/lib/udev/rules.d/40-redhat.rules >> /etc/udev/rules.d/40-redhat.rules
	/bin/echo -e '# there was edited by dr-util\nLABEL="dr_end"' >> /etc/udev/rules.d/40-redhat.rules
fi
## create symlinks
ln -sf $RPM_BUILD_ROOT%{dp_sbin_dir}/dr /sbin/dr
ln -sf $RPM_BUILD_ROOT%{dp_lib_dir}/dp.py %{python_lib}/dp.py
ln -sf $RPM_BUILD_ROOT%{dp_lib_dir}/ipmi.py %{python_lib}/ipmi.py
ln -sf $RPM_BUILD_ROOT%{dp_lib_dir}/dp_compat.py %{python_lib}/dp_compat.py
ln -sf $RPM_BUILD_ROOT%{dp_lib_dir}/notify.py %{python_lib}/notify.py
ln -sf $RPM_BUILD_ROOT%{dp_tools_dir}/FJSVdr-util.rules \
	$RPM_BUILD_ROOT%{udev_rule_dir}/96-FJSVdr-util.rules
## add boot option for DR
DP_BOOT_OPT=%{dp_boot_opt}
if [ -f %{default_grub} ]; then
	GRUB_CMDLINE_LINUX=`cat %{default_grub} | grep '^GRUB_CMDLINE_LINUX='|sed -e 's/GRUB_CMDLINE_LINUX=//g' | sed -e 's/^"//g' | sed -e 's/"$//g'`
	NEW_CMDLINE=$GRUB_CMDLINE_LINUX
	for DP_OPT in ${DP_BOOT_OPT[@]}
	do
	        NEW_CMDLINE=$(echo "$NEW_CMDLINE" | sed -e 's/\<'$DP_OPT'\>//g')
	        NEW_CMDLINE=$(echo "$NEW_CMDLINE" | sed -e 's/$/ '$DP_OPT'/g')
	done
	# cleanup obsolete dp options
	NEW_CMDLINE=$(echo "$NEW_CMDLINE" | sed -e 's/\<'pci=hpmemsize=4m'\>//g')

	# for Haswell
	NODE_MEM=()
	# define memory block size from block_size_bytes
	if [ -e /sys/devices/system/memory/block_size_bytes ]; then
		SECTION_SIZE=`cat /sys/devices/system/memory/block_size_bytes`
		SECTION_SIZE=`echo "obase=10; ibase=16; $SECTION_SIZE" | /usr/bin/bc`
	else
		SECTION_SIZE=134217728
	fi
	for NODE in `ls /sys/devices/system/node|grep node|sort -r`
	do
		# find first memory section in the node
		MEM=`ls /sys/devices/system/node/$NODE/|grep memory|sed -e 's/memory//g'|sort -g|head -n 1`
		# add $MEM to $NODE_MEM array
		NODE_MEM=("${NODE_MEM[@]}" $MEM)
	done

	# sort memory in ascending order
	SORTED_MEM=($(for MEM in "${NODE_MEM[@]}"; do echo "$MEM"; done|sort -n))
	# calculate mem= value. SORTED_MEM[1] is Node of HomeSB not including BSP
	MEM_ALIGN=`expr ${SORTED_MEM[1]} \* 2`
	MEM_ALIGN=`expr ${MEM_ALIGN} \* $SECTION_SIZE`
	# confirm the system is Ivy-brg or Haswell
	if [ $MEM_ALIGN != 4398046511104 ]
	then
		# convert $MEM_ALIGN from decimal to hexadecimal
		MEM_ALIGN_HEX=`echo "obase=16; ibase=10; $MEM_ALIGN" | /usr/bin/bc`
		# prepare new mem= option for Haswell
		NEW_MEM_OPTION="mem=0x$MEM_ALIGN_HEX"
		# clear mem=0x40000000000 boot option
		NEW_CMDLINE=$(echo "$NEW_CMDLINE" | sed -e 's/\<'mem=0x40000000000'\>//g')
		# add mem= boot option for Hasewll
		NEW_CMDLINE=$(echo "$NEW_CMDLINE" | sed -e 's/\<'$NEW_MEM_OPTION'\>//g')
		NEW_CMDLINE=$(echo "$NEW_CMDLINE" | sed -e 's/$/ '$NEW_MEM_OPTION'/g')
	fi

	NEW_CMDLINE="GRUB_CMDLINE_LINUX=\"$NEW_CMDLINE\""
	
	sed -i '/^GRUB_CMDLINE_LINUX=/d' %{default_grub}
	echo $NEW_CMDLINE >> %{default_grub}
	grub2-mkconfig -o %{grub_cfg} > /dev/null 2>&1
else
	KERNEL_LIST=$(/bin/ls /boot/vmlinuz-*)
	for KERNEL in ${KERNEL_LIST[@]}
	do
		/sbin/grubby --update-kernel $KERNEL --args="$DP_BOOT_OPT"
	done
fi

# To disable 40-redhat.rules in initramfs, update initramfs
dracut -f /boot/initramfs-$(uname -r).img $(uname -r)

%preun
if [ "$1" = 0 ]; then  # when rpm -e
	## uninstall service
	/usr/bin/systemctl --no-reload disable FJSVdr-util-enable.service \
		>/dev/null 2>&1
	/usr/bin/systemctl --no-reload disable FJSVdr-util-event-daemon.service \
		>/dev/null 2>&1
	/usr/bin/systemctl --no-reload disable FJSVdr-util-enable-removable-sb.service \
		>/dev/null 2>&1
	/usr/bin/systemctl stop FJSVdr-util-enable.service >/dev/null 2>&1
	/usr/bin/systemctl stop FJSVdr-util-event-daemon.service >/dev/null 2>&1
	/usr/bin/systemctl stop FJSVdr-util-enable-removable-sb.service >/dev/null 2>&1
		
	## cleanup symlinks
	if [ -f $RPM_BUILD_ROOT%{dp_sbin_dir}/dp_main.py ];
	then
		rm -f $RPM_BUILD_ROOT%{dp_sbin_dir}/dp_main.py
	fi	
	if [ -f /sbin/dr ];
	then
		rm -f /sbin/dr
	fi
	if [ -f $RPM_BUILD_ROOT%{python_lib}/dp.py ];
	then
		rm -f $RPM_BUILD_ROOT%{python_lib}/dp.py
	fi
	if [ -f $RPM_BUILD_ROOT%{python_lib}/ipmi.py ];
	then
		rm -f $RPM_BUILD_ROOT%{python_lib}/ipmi.py
	fi
	if [ -f $RPM_BUILD_ROOT%{python_lib}/dp_compat.py ];
	then
		rm -f $RPM_BUILD_ROOT%{python_lib}/dp_compat.py
	fi	
	if [ -f $RPM_BUILD_ROOT%{python_lib}/notify.py ];
	then
		rm -f $RPM_BUILD_ROOT%{python_lib}/notify.py
	fi	
	if [ -f $RPM_BUILD_ROOT%{udev_rule_dir}/96-FJSVdr-util.rules ];
	then
		rm -f $RPM_BUILD_ROOT%{udev_rule_dir}/96-FJSVdr-util.rules
	fi
fi

%postun
if [ "$1" = 0 ]; then	# when rpm -e
    ## remove boot option for DR
	DP_BOOT_OPT=%{dp_boot_opt}
	if [ -f %{default_grub} ]; then
		GRUB_CMDLINE_LINUX=`cat %{default_grub} | grep '^GRUB_CMDLINE_LINUX='|sed -e 's/GRUB_CMDLINE_LINUX=//g' | sed -e 's/^"//g' | sed -e 's/"$//g'`
		NEW_CMDLINE=$GRUB_CMDLINE_LINUX
		for DP_OPT in ${DP_BOOT_OPT[@]}
		do
		        NEW_CMDLINE=$(echo "$NEW_CMDLINE" | sed -e 's/\<'$DP_OPT'\>//g')
		done
		# cleanup obsolete dp options
		NEW_CMDLINE=$(echo "$NEW_CMDLINE" | sed -e 's/\<'pci=hpmemsize=4m'\>//g')
		# cleanup mem=boot option for Haswell
		NEW_CMDLINE=$(echo "$NEW_CMDLINE" | sed -e 's/\<'mem=[a-zA-Z0-9]*'\>//g')
		
		NEW_CMDLINE="GRUB_CMDLINE_LINUX=\"$NEW_CMDLINE\""
		
		sed -i '/^GRUB_CMDLINE_LINUX=/d' %{default_grub}
		echo $NEW_CMDLINE >> %{default_grub}
		grub2-mkconfig -o %{grub_cfg} > /dev/null 2>&1
	else
		KERNEL_LIST=$(/bin/ls /boot/vmlinuz-*)
		for KERNEL in ${KERNEL_LIST[@]}
		do
			/sbin/grubby --update-kernel $KERNEL --remove-args="$DP_BOOT_OPT"
		done
	fi
	## for kdump
	if [ -f /etc/udev/rules.d/98-kexec.rules ]; then
		if [ -f /etc/redhat-release ]; then
			# find distribution version
			VER=`cut -d " " -f 7 /etc/redhat-release`
			if [ $VER == "7.0" ]; then
				/bin/sed -i -e "s/^#//g" /etc/udev/rules.d/98-kexec.rules
			else
				/bin/rm -rf /etc/udev/rules.d/98-kexec.rules
			fi
		fi
	fi

	## for CPU online/offline
	if [ -f /etc/udev/rules.d/40-redhat.rules ]; then
		/bin/rm -rf /etc/udev/rules.d/40-redhat.rules
	fi
fi
/usr/bin/systemctl daemon-reload >/dev/null 2>&1
if [ "$1" -ge 1 ]; then # upgrade, not uninstall
	/usr/bin/systemctl try-restart \
		FJSVdr-util-enable.service >/dev/null 2>&1
	/usr/bin/systemctl try-restart \
		FJSVdr-util-event-daemon.service >/dev/null 2>&1
	/usr/bin/systemctl try-restart \
		FJSVdr-util-enable-removable-sb.service >/dev/null 2>&1
fi

# To disable 40-redhat.rules in initramfs, update initramfs
dracut -f /boot/initramfs-$(uname -r).img $(uname -r)

%clean
[ "$RPM_BUILD_ROOT" != "/" ] && rm -rf $RPM_BUILD_ROOT

%files
%defattr(-,root,root,-)
%{dp_home_dir}
%config(noreplace) %{dp_etc_dir}/dr_report.conf
%config(noreplace) %{_sysconfdir}/logrotate.d/FJSVdr-util
%{systemd_dir}/FJSVdr-util-enable.service
%{systemd_dir}/FJSVdr-util-event-daemon.service
%{systemd_dir}/FJSVdr-util-enable-removable-sb.service

%changelog
* Wed Sep 26 2018 FUJITSU LIMITED [RHEL7-1.8.0-1]
- Fix sectionsize calculation.
- Change rules for 40-redhat.rules
  (BS01664)

* Fri Sep  8 2017 FUJITSU LIMITED [RHEL7-1.7.0-1]
- Support for PRIMEQUEST 3000 series.
  Updating Specfile to add bc to Requires.
  (BS01635)

* Mon Apr 11 2016 FUJITSU LIMITED [RHEL7-1.6.0-1]
- Do not send IPMI in case of failure after ejecting SB.
  (BS01625)

* Thu Feb 26 2016 FUJITSU LIMITED [RHEL7-1.5.0-1]
- Revert changes of RHEL7-1.4.0-1. This version is same as RHEL7-1.3.0-1.
  (BS01623)

* Thu Jan 19 2016 FUJITSU LIMITED
- notsc option is set on only 2400E/2800E/2400L/2800L and
  2400E2/2800E2/2400L2/2800L2.
  (BS01617)

* Fri Oct 20 2015 FUJITSU LIMITED
- Updating initramfs to disable 40-redhat.rules.
  By the changes of systemd (Bugzilla 1241547), initramfs includes 40-redhat.rules,
  which is an udev rule file. 40-redhat.rules in initramfs changes the offlined memory
  to online (not movable) while the system is booted. As the result, we can not do SB
  hot-remove.
  In this change, dr util disables it by updating initramfs after dr util does
  comment out the cpu and memory hot-plug rules in 40-redhat.rules.
  (BS01615)

* Fri Feb 13 2015 FUJITSU LIMITED
- Modify dr util for RHEL7.1 and Haswell
- Support new ACPI specification of kernel layer for RHEL7.1.
- Restart several services for SB hotplug for RHEL7.1.
- Support ACPI0007 and new mem= boot option for Haswell.
- (BS01598)

* Thu Aug 28 2014 FUJITSU LIMITED
- Do not send IPMI error code in case of minor errors in IOU hotplug
- Change the value of pci=hpmemsize boot option (Specfile)
- (BS01586)

* Thu Apr 30 2014 FUJITSU LIMITED
- first build
- (BS01571)
